diff --git a/.gitignore b/.gitignore
index 28896cf6..e828ea01 100644
--- a/.gitignore
+++ b/.gitignore
@@ -20,6 +20,7 @@ docs/web/
 *.7z
 *.dmg
 *.gz
+*.xz
 *.iso
 *.jar
 *.rar
diff --git a/.travis.yml b/.travis.yml
index d16afb57..644eb33f 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -2,24 +2,7 @@ sudo: required
 
 language: c
 
-env:
-  global:
-   # The next declaration is the encrypted COVERITY_SCAN_TOKEN, created
-   #   via the "travis encrypt" command using the project repo's public key
-   - secure: "F/PkNS6cxaD8Stj3ZdfnRMs5YIb4kRz1QQFwTYJu5o0F8IzGlow11AjqgGWov0KbbYaZGIGN5DlNUtOvUuNcqaPpkoHohoDBO/TcDLgVzwhBNLBCm1bho6DHuuSX1MKo+TWS1xJLCx+1+oRvSCLNjTrI3gYFwksrJhfDf9fw6VI="
-
-before_install:
-      - echo -n | openssl s_client -connect scan.coverity.com:443 | sed -ne '/-BEGIN CERTIFICATE-/,/-END CERTIFICATE-/p' | sudo tee -a /etc/ssl/certs/ca-
-
 addons:
-  coverity_scan:
-    project:
-      name: "appneta/tcpreplay"
-      description: "Build submitted via Travis CI"
-    notification_email: fklassen@appneta.com
-    build_command_prepend: "./autogen.sh; ./configure; make clean"
-    build_command:   "make"
-    branch_pattern: coverity_scan
   apt:
     packages:
     - libpcap-dev
diff --git a/Makefile.am b/Makefile.am
index cf59f343..75b68ec2 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1,6 +1,4 @@
 # $Id$
-AUTOMAKE_OPTIONS = foreign
-
 ACLOCAL_AMFLAGS = -I m4 -I libopts/m4
 
 if NEED_LIBOPTS
diff --git a/configure.ac b/configure.ac
index 6a7c9306..8dd7a6d2 100644
--- a/configure.ac
+++ b/configure.ac
@@ -2,9 +2,14 @@
 dnl $Id$
 
 AC_PREREQ([2.69])
-AC_INIT([tcpreplay],[4.2.0],[https://github.com/appneta/tcpreplay/issues],[tcpreplay],[http://tcpreplay.sourceforge.net/])
+
+dnl Set version info here!
+AC_INIT([tcpreplay],[4.2.0],
+    [https://github.com/appneta/tcpreplay/issues],
+    [tcpreplay],
+    [http://tcpreplay.sourceforge.net/])
 AC_CONFIG_SRCDIR([src/tcpreplay.c])
-AM_CONFIG_HEADER([src/config.h])
+AC_CONFIG_HEADERS([src/config.h])
 AC_CONFIG_AUX_DIR(config)
 AM_MAINTAINER_MODE
 AM_WITH_DMALLOC
@@ -15,23 +20,16 @@ MAINTAINER_AUTOGEN_VERSION=5.18.4
 
 AC_CONFIG_MACRO_DIR([m4])
 
-dnl Set version info here!
-MAJOR_VERSION=4
-MINOR_VERSION=2
-MICRO_VERSION=0-beta1
-TCPREPLAY_VERSION=$MAJOR_VERSION.$MINOR_VERSION.$MICRO_VERSION
-PACKAGE_URL=http://tcpreplay.appneta.com/
+TCPREPLAY_VERSION=$PACKAGE_VERSION
 
 dnl Release is only used for the RPM spec file
 TCPREPLAY_RELEASE=1
 
-AC_DEFINE(PACKAGE, [tcpreplay], [This is our package name])
-AC_DEFINE_UNQUOTED(VERSION, "$TCPREPLAY_VERSION", [What is our version?])
 AC_SUBST(TCPREPLAY_VERSION)
 AC_SUBST(TCPREPLAY_RELEASE)
 
 USER_CFLAGS=$CFLAGS
-CFLAGS="-Wall -O3 -std=gnu99 ${CFLAGS}"
+CFLAGS="-Wall -std=gnu99 ${CFLAGS}"
 
 dnl Determine OS
 AC_CANONICAL_BUILD
@@ -141,7 +139,7 @@ else
 fi
 
 
-AM_INIT_AUTOMAKE(tcpreplay, $TCPREPLAY_VERSION, nodefine)
+AM_INIT_AUTOMAKE([foreign])
 AM_SILENT_RULES([yes])
 
 dnl Checks for programs.
diff --git a/docs/CHANGELOG b/docs/CHANGELOG
index 5c26d78e..8a1754b3 100644
--- a/docs/CHANGELOG
+++ b/docs/CHANGELOG
@@ -1,15 +1,17 @@
-02/26/2017 Version 4.2.0beta2
+02/26/2017 Version 4.2.0
     - MAC rewriting capabilities (#313)
     - Fix several issues identified by Coverity (#305)
-    - Netmap startup delay increase (#209)
+    - Packet destortion --fuzz-seed option by Gabriel Ganne (#302)
+    - Add --unique-ip-loops option to modify IPs every few loops (#296)
+    - Netmap startup delay increase (#290)
     - tcpcapinfo buffer overflow vulnerablily (#278)
     - Update git-clone instructions by Kyle McDonald (#277) 
     - Allow fractions for --pps option (#270)
     - Print per-loop stats with --stats=0 (#269)
     - Add protection against packet drift by Guillaume Scott (#268)
     - Include Travis-CI build support by Ilya Shipitsin (#264) (#285)
-    - Netmap shutdown delay implemention (#255)
     - First and last packet times in --stats output (#239)
+    - Switch to wire speed after 30 minutes at 6 Gbps (#210)
     - tcprewrite fix checksum properly for fragmented packets (#190)
 
 11/19/2016 Version 4.1.2
@@ -27,7 +29,6 @@
     - Option --duration performance optimizations (#223)
     - Correct company name in license (#217)
     - Compile and mult-arch cross-compile on ARM (#211)
-    - Switch to wire speed after 30 minutes at 6 Gbps (#210)
     - Tap device support for Linux and FreeBSD from Murat Demirten (#207)
     - Handle loopback for linux cooked capture files from corentin-p1(Linux SLL) (#204)
     - Master doesn't compile on OS X 10.11 (#203)
diff --git a/libopts/parse-duration.c b/libopts/parse-duration.c
index ff3fe422..43ee5a63 100644
--- a/libopts/parse-duration.c
+++ b/libopts/parse-duration.c
@@ -83,14 +83,14 @@ scale_n_add (time_t base, time_t val, int scale)
       return BAD_TIME;
     }
 
-  if (val > MAX_DURATION / scale)
+  if (val >= MAX_DURATION / scale)
     {
       errno = ERANGE;
       return BAD_TIME;
     }
 
   val *= scale;
-  if (base > MAX_DURATION - val)
+  if ((base + val) >= MAX_DURATION)
     {
       errno = ERANGE;
       return BAD_TIME;
diff --git a/src/Makefile.am b/src/Makefile.am
index 09852525..48a58d82 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -78,6 +78,7 @@ tcpreplay_LDADD = ./common/libcommon.a $(LIBSTRL) @LPCAPLIB@ @LDNETLIB@ $(LIBOPT
 tcpreplay_OBJECTS: tcpreplay_opts.h
 tcpreplay_opts.h: tcpreplay_opts.c
 
+BUILT_SOURCES += tcpreplay_opts.h
 tcpreplay_opts.c: tcpreplay_opts.def
 	@AUTOGEN@ $(opts_list) @NETMAPFLAGS@ tcpreplay_opts.def
 
diff --git a/src/common/cache.c b/src/common/cache.c
index 94ceca98..1e481415 100644
--- a/src/common/cache.c
+++ b/src/common/cache.c
@@ -73,6 +73,9 @@ read_cache(char **cachedata, const char *cachefile, char **comment)
     ssize_t read_size = 0;
     COUNTER cache_size = 0;
 
+    assert(cachedata);
+    assert(comment);
+
     /* open the file or abort */
     if ((cachefd = open(cachefile, O_RDONLY)) == -1)
         errx(-1, "unable to open %s:%s", cachefile, strerror(errno));
@@ -99,11 +102,12 @@ read_cache(char **cachedata, const char *cachefile, char **comment)
 
     dbgx(1, "Comment length: %d", header.comment_len);
     
-    if ((read_size = read(cachefd, *comment, header.comment_len)) 
-            != (ssize_t)header.comment_len)
-        errx(-1, "Unable to read %d bytes of data for the comment (%zd) %s",
-            header.comment_len, read_size, 
-            (read_size == -1) ? strerror(read_size) : "");
+    if ((read_size = read(cachefd, *comment, header.comment_len)) < 0)
+        errx(-1, "Error reading comment: %s", strerror(errno));
+
+    if (read_size != (ssize_t)header.comment_len)
+        errx(-1, "Invalid comment read: expected=%u actual=%zd bytes",
+            header.comment_len, read_size);
 
     dbgx(1, "Cache file comment: %s", *comment);
 
diff --git a/src/common/utils.c b/src/common/utils.c
index 300afcc8..eb636da1 100644
--- a/src/common/utils.c
+++ b/src/common/utils.c
@@ -26,6 +26,7 @@
 #include <stdlib.h>
 #include <errno.h>
 #include <ctype.h>
+#include <unistd.h>
 
 #ifdef DEBUG
 extern int debug;
@@ -144,30 +145,33 @@ packet_stats(const tcpreplay_stats_t *stats)
     timersub(&stats->end_time, &stats->start_time, &diff);
     diff_us = TIMEVAL_TO_MICROSEC(&diff);
 
-    if (diff_us) {
-        if (stats->bytes_sent){
-            COUNTER bytes_sec_X10;
-            COUNTER mb_sec_X100;
+    if (diff_us && stats->pkts_sent && stats->bytes_sent) {
+        COUNTER bytes_sec_X10;
+        COUNTER pkts_sec_X100;
+        COUNTER mb_sec_X1000;
+        COUNTER mb_sec_X100;
+
+        if (stats->bytes_sent > 1000 * 1000 * 1000 && diff_us > 1000 * 1000) {
+            bytes_sec_X10 = (stats->bytes_sent * 10 * 1000) / (diff_us / 1000);
+            pkts_sec_X100 = (stats->pkts_sent * 100 * 1000) / (diff_us / 1000);
+         } else {
+            bytes_sec_X10 = (stats->bytes_sent * 10 * 1000 * 1000) / diff_us;
+            pkts_sec_X100 = (stats->pkts_sent * 100 * 1000 * 1000) / diff_us;
+         }
 
-            bytes_sec_X10 = ((stats->bytes_sent  * 10 * 1000) / diff_us) * 1000;
-            bytes_sec = bytes_sec_X10 / 10;
-            bytes_sec_10ths = bytes_sec_X10 % 10;
+        bytes_sec = bytes_sec_X10 / 10;
+        bytes_sec_10ths = bytes_sec_X10 % 10;
 
-            mb_sec_X100 = (bytes_sec * 8) / (10 * 1000);
-            mb_sec = mb_sec_X100 / 100;
-            mb_sec_100ths = mb_sec_X100 % 100;
-            mb_sec_1000ths = (bytes_sec * 8) / 1000;
-        }
-        if (stats->pkts_sent) {
-            COUNTER pkts_sec_X100;
+        mb_sec_X1000 = (bytes_sec * 8) / 1000;
+        mb_sec_X100 = mb_sec_X1000 / 10;
+        mb_sec = mb_sec_X1000 / 1000;
+        mb_sec_100ths = mb_sec_X100 % 100;
 
-            pkts_sec_X100 = (stats->pkts_sent * 100 * 1000 * 1000) / diff_us;
-            pkts_sec = pkts_sec_X100 / 100;
-            pkts_sec_100ths = pkts_sec_X100 % 100;
-        }
+        pkts_sec = pkts_sec_X100 / 100;
+        pkts_sec_100ths = pkts_sec_X100 % 100;
     }
 
-    if (diff_us >= 1000000)
+    if (diff_us >= 1000 * 1000)
         printf("Actual: " COUNTER_SPEC " packets (" COUNTER_SPEC " bytes) sent in %zd.%02zd seconds\n",
                 stats->pkts_sent, stats->bytes_sent, (ssize_t)diff.tv_sec, (ssize_t)(diff.tv_usec / (10 * 1000)));
     else
@@ -184,7 +188,7 @@ packet_stats(const tcpreplay_stats_t *stats)
     fflush(NULL);
     
     if (stats->failed)
-        printf(COUNTER_SPEC " write attempts failed from full buffers and were repeated\n",
+        printf("Failed write attempts: " COUNTER_SPEC "\n",
                 stats->failed);
 }
 
@@ -310,3 +314,34 @@ uint32_t __div64_32(uint64_t *n, uint32_t base)
     return rem;
 }
 #endif /* SIZEOF_CHARP  == 4 */
+
+/**
+ * Implementation of rand_r that is consistent across all platforms
+ * This algorithm is mentioned in the ISO C standard, here extended
+ * for 32 bits.
+ * @param: seed
+ * @return: random number
+ */
+int tcpr_random(uint32_t *seed)
+{
+  unsigned int next = *seed;
+  int result;
+
+  next *= 1103515245;
+  next += 12345;
+  result = (unsigned int) (next / 65536) % 2048;
+
+  next *= 1103515245;
+  next += 12345;
+  result <<= 10;
+  result ^= (unsigned int) (next / 65536) % 1024;
+
+  next *= 1103515245;
+  next += 12345;
+  result <<= 10;
+  result ^= (unsigned int) (next / 65536) % 1024;
+
+  *seed = next;
+
+  return result;
+}
diff --git a/src/common/utils.h b/src/common/utils.h
index fc95f7c7..59584c40 100644
--- a/src/common/utils.h
+++ b/src/common/utils.h
@@ -47,6 +47,7 @@ typedef struct {
 int read_hexstring(const char *l2string, u_char *hex, const int hexlen);
 void packet_stats(const tcpreplay_stats_t *stats);
 int format_date_time(struct timeval *when, char *buf, size_t len);
+int tcpr_random(uint32_t *seed);
 
 /* our "safe" implimentations of functions which allocate memory */
 #define safe_malloc(x) _our_safe_malloc(x, __FUNCTION__, __LINE__, __FILE__)
diff --git a/src/config.h.in b/src/config.h.in
index 8d2bfc5b..66995553 100644
--- a/src/config.h.in
+++ b/src/config.h.in
@@ -618,7 +618,7 @@
 /* Define this if optional arguments are disallowed */
 #undef NO_OPTIONAL_OPT_ARGS
 
-/* This is our package name */
+/* Name of package */
 #undef PACKAGE
 
 /* Define to the address where bug reports for this package should be sent. */
@@ -675,7 +675,7 @@
 /* Define to 1 if you can safely include both <sys/time.h> and <time.h>. */
 #undef TIME_WITH_SYS_TIME
 
-/* What is our version? */
+/* Version number of package */
 #undef VERSION
 
 /* Define if using the dmalloc debugging malloc package */
diff --git a/src/defines.h.in b/src/defines.h.in
index 00e547f4..bbd3501b 100644
--- a/src/defines.h.in
+++ b/src/defines.h.in
@@ -83,6 +83,7 @@
 #define COUNTER unsigned long
 #define COUNTER_SPEC "%lu"
 #endif
+#define COUNTER_OVERFLOW_RISK (((COUNTER)~0) >> 20)
 
 #include "common/list.h"
 #include "common/cidr.h"
diff --git a/src/send_packets.c b/src/send_packets.c
index 29f49bfb..24eaea13 100644
--- a/src/send_packets.c
+++ b/src/send_packets.c
@@ -459,6 +459,18 @@ preload_pcap_file(tcpreplay_t *ctx, int idx)
     pcap_close(pcap);
 }
 
+static void increment_iteration(tcpreplay_t *ctx)
+{
+    tcpreplay_opt_t *options = ctx->options;
+
+    ++ctx->iteration;
+    if (options->unique_ip) {
+        assert(options->unique_loops > 0.0);
+        ctx->unique_iteration =
+                (COUNTER)((float)ctx->iteration / options->unique_loops) + 1;
+    }
+}
+
 /**
  * the main loop function for tcpreplay.  This is where we figure out
  * what to do with each packet
@@ -483,8 +495,6 @@ send_packets(tcpreplay_t *ctx, pcap_t *pcap, int idx)
     COUNTER skip_length = 0;
     COUNTER start_us;
     COUNTER end_us;
-    COUNTER iteration = ctx->iteration;
-    bool unique_ip = options->unique_ip;
     bool preload = options->file_cache[idx].cached;
     bool top_speed = (options->speed.mode == speed_topspeed);
     bool now_is_now = false;
@@ -548,10 +558,13 @@ send_packets(tcpreplay_t *ctx, pcap_t *pcap, int idx)
             tcpdump_print(options->tcpdump, &pkthdr, pktdata);
 #endif
 
-        if (unique_ip && iteration)
+        if (ctx->options->unique_ip && ctx->unique_iteration &&
+                ctx->unique_iteration > ctx->last_unique_iteration) {
+            ctx->last_unique_iteration = ctx->unique_iteration;
             /* edit packet to ensure every pass has unique IP addresses */
-            fast_edit_packet(&pkthdr, &pktdata, iteration,
+            fast_edit_packet(&pkthdr, &pktdata, ctx->unique_iteration,
                     preload, datalink);
+        }
 
         /* update flow stats */
         if (options->flow_stats && !preload)
@@ -683,7 +696,7 @@ send_packets(tcpreplay_t *ctx, pcap_t *pcap, int idx)
 
     memcpy(&ctx->stats.end_time, &now, sizeof(ctx->stats.end_time));
 
-    ++ctx->iteration;
+    increment_iteration(ctx);
 }
 
 /**
@@ -702,8 +715,6 @@ send_dual_packets(tcpreplay_t *ctx, pcap_t *pcap1, int cache_file_idx1, pcap_t *
     u_char *pktdata1 = NULL, *pktdata2 = NULL, *pktdata = NULL;
     sendpacket_t *sp = ctx->intf1;
     COUNTER pktlen;
-    COUNTER iteration = ctx->iteration;
-    bool unique_ip = options->unique_ip;
     packet_cache_t *cached_packet1 = NULL, *cached_packet2 = NULL;
     packet_cache_t **prev_packet1 = NULL, **prev_packet2 = NULL;
     struct pcap_pkthdr *pkthdr_ptr;
@@ -806,10 +817,13 @@ send_dual_packets(tcpreplay_t *ctx, pcap_t *pcap1, int cache_file_idx1, pcap_t *
             tcpdump_print(options->tcpdump, pkthdr_ptr, pktdata);
 #endif
 
-        if (unique_ip && iteration)
+        if (ctx->options->unique_ip && ctx->unique_iteration &&
+                ctx->unique_iteration > ctx->last_unique_iteration) {
+            ctx->last_unique_iteration = ctx->unique_iteration;
             /* edit packet to ensure every pass is unique */
-            fast_edit_packet(pkthdr_ptr, &pktdata, ctx->iteration,
+            fast_edit_packet(pkthdr_ptr, &pktdata, ctx->unique_iteration,
                     options->file_cache[cache_file_idx].cached, datalink);
+        }
 
         /* update flow stats */
         if (options->flow_stats && !options->file_cache[cache_file_idx].cached)
@@ -943,7 +957,7 @@ send_dual_packets(tcpreplay_t *ctx, pcap_t *pcap1, int cache_file_idx1, pcap_t *
 
     memcpy(&ctx->stats.end_time, &now, sizeof(ctx->stats.end_time));
 
-    ++ctx->iteration;
+    increment_iteration(ctx);
 }
 
 
@@ -1141,11 +1155,19 @@ static bool calc_sleep_time(tcpreplay_t *ctx, struct timeval *pkt_time_delta,
          */
         now_us = TIMSTAMP_TO_MICROSEC(sent_timestamp);
         if (now_us) {
+            COUNTER next_tx_us;
             COUNTER bps = options->speed.speed;
             COUNTER bits_sent = ((ctx->stats.bytes_sent + len) * 8);
-            /* bits * 1000000 divided by bps = microseconds */
-            COUNTER next_tx_us = (bits_sent * 1000000) / bps;
             COUNTER tx_us = now_us - *start_us;
+            /*
+             * bits * 1000000 divided by bps = microseconds
+             *
+             * ensure there is no overflow in cases where bits_sent is very high
+             */
+            if (bits_sent > COUNTER_OVERFLOW_RISK && bps > 500000)
+                next_tx_us = (bits_sent * 1000) / bps * 1000;
+            else
+                next_tx_us = (bits_sent * 1000000) / bps;
             if (next_tx_us > tx_us) {
                 NANOSEC_TO_TIMESPEC((next_tx_us - tx_us) * 1000, &ctx->nap);
             } else if (tx_us > next_tx_us) {
diff --git a/src/tcpedit/Makefile.am b/src/tcpedit/Makefile.am
index b324c791..cfcd2653 100644
--- a/src/tcpedit/Makefile.am
+++ b/src/tcpedit/Makefile.am
@@ -27,7 +27,8 @@ AM_CFLAGS = -I.. -I../common -I../.. @LDNETINC@ $(LIBOPTS_CFLAGS) $(LNAV_CFLAGS)
 noinst_HEADERS = tcpedit.h edit_packet.h portmap.h \
 	tcpedit_stub.h parse_args.h dlt.h checksum.h \
 	incremental_checksum.h tcpedit_api.h \
-	tcpedit_types.h plugins.h plugins_api.h plugins_types.h
+	tcpedit_types.h plugins.h plugins_api.h \
+	plugins_types.h fuzzing.h
 
 MOSTLYCLEANFILES = *~
 
diff --git a/src/tcpedit/fuzzing.c b/src/tcpedit/fuzzing.c
index 960ca857..82d7182f 100644
--- a/src/tcpedit/fuzzing.c
+++ b/src/tcpedit/fuzzing.c
@@ -10,13 +10,15 @@
 
 #include "tcpedit/tcpedit.h"
 
-static unsigned int fuzz_seed = 0;
+static unsigned int fuzz_seed;
+static unsigned int fuzz_running;
+
 
 void
 fuzzing_init(unsigned int _fuzz_seed)
 {
     fuzz_seed = _fuzz_seed;
-    srand(fuzz_seed);
+    fuzz_running = 1;
 }
 
 #define SGT_MAX_SIZE 16
@@ -35,8 +37,8 @@ fuzz_get_sgt_size(uint32_t r, uint32_t caplen)
 }
 
 static inline int
-fuzz_reduce_packet_size(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr,
-        u_char **pktdata, COUNTER new_len)
+fuzz_reduce_packet_size(tcpedit_t * tcpedit, struct pcap_pkthdr * pkthdr,
+        COUNTER new_len)
 {
     assert(new_len <= pkthdr->len);
 
@@ -58,25 +60,100 @@ fuzz_reduce_packet_size(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr,
     return 1;
 }
 
+
+static inline int
+fuzz_get_datalen(tcpedit_t * tcpedit, struct pcap_pkthdr * pkthdr,
+        u_char ** pktdata)
+{
+    int datalen;
+    uint8_t l4proto;
+    u_char * l3data, * l4data;
+
+    datalen = pkthdr->len;
+
+    l3data = tcpedit->dlt_ctx->encoder->plugin_get_layer3(tcpedit->dlt_ctx,
+            *pktdata, pkthdr->caplen);
+    if (l3data == NULL) {
+        return -1;
+    }
+    datalen -= l3data - *pktdata;
+
+    if (datalen <= 0) {
+        return -1;
+    }
+
+    /* switch on layer 2 */
+    switch (ntohs(tcpedit->dlt_ctx->proto))
+    {
+        /* TODO: ntohs on constants could be done at compile time */
+        case (ETHERTYPE_IP):
+            {
+                l4data = get_layer4_v4((ipv4_hdr_t*) l3data, datalen);
+                if (l4data == NULL) {
+                    return -1;
+                }
+                l4proto = ((ipv4_hdr_t *) l3data)->ip_p;
+                break;
+            }
+        case (ETHERTYPE_IP6):
+            {
+                l4data = get_layer4_v6((ipv6_hdr_t*) l3data, datalen);
+                if (l4data == NULL) {
+                    return -1;
+                }
+                l4proto = ((ipv6_hdr_t *) l3data)->ip_nh;
+                break;
+            }
+        default:
+            /* apply fuzzing on unknown packet types */
+            return datalen;
+    }
+
+    datalen -= (l4data - l3data);
+
+    /* switch on layer 3 */
+    switch (l4proto) {
+        case IPPROTO_TCP:
+            datalen -= sizeof(tcp_hdr_t);
+            break;
+        case IPPROTO_UDP:
+            datalen -= sizeof(udp_hdr_t);
+            break;
+    }
+
+    return datalen;
+}
+
 int
-fuzzing(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr,
-        u_char **pktdata)
+fuzzing(tcpedit_t * tcpedit, struct pcap_pkthdr * pkthdr,
+        u_char ** _pktdata)
 {
     int packet_changed;
     uint32_t r;
     unsigned int * len;
+    int datalen;
+    u_char * pktdata;
 
     assert(tcpedit != NULL);
     assert(pkthdr != NULL);
-    assert(pktdata != NULL);
+    assert(_pktdata != NULL);
 
-    if (fuzz_seed == 0) {
+    if (fuzz_running == 0) {
         return 0;
     }
 
     len = &(pkthdr->caplen);
     packet_changed = 0;
+
+    /* skip packets without payload */
+    datalen = fuzz_get_datalen(tcpedit, pkthdr, _pktdata);
+    if (datalen <= 0 || datalen >= *len) {
+        return 0;
+    }
+
     r = rand();
+    r = tcpr_random(&fuzz_seed);
+    pktdata = *_pktdata + (*len - datalen);
 
     /* TODO sktip ip/tcp/udp headers */
 
@@ -91,7 +168,7 @@ fuzzing(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr,
             case FUZZING_DROP_PACKET:
                 {
                     /* simulate droping the packet */
-                    packet_changed = fuzz_reduce_packet_size(tcpedit, pkthdr, pktdata, 0);
+                    packet_changed = fuzz_reduce_packet_size(tcpedit, pkthdr, 0);
                     if (packet_changed < 0) {
                         /* could not change packet size, so packet left unchanged */
                         return 0;
@@ -102,7 +179,7 @@ fuzzing(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr,
                 {
                     /* reduce packet size */
                     uint32_t new_len = (r % ((*len) - 1)) + 1;
-                    packet_changed = fuzz_reduce_packet_size(tcpedit, pkthdr, pktdata, new_len);
+                    packet_changed = fuzz_reduce_packet_size(tcpedit, pkthdr, new_len);
                     if (packet_changed < 0) {
                         /* could not change packet size, so packet left unchanged */
                         return 0;
@@ -113,9 +190,8 @@ fuzzing(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr,
             case FUZZING_CHANGE_START_ZERO:
                 {
                     /* fuzz random-size segment at the begining of the packet with 0x00 */
-                    uint32_t r = rand();
-                    uint32_t sgt_size = fuzz_get_sgt_size(r, (*len));
-                    memset((*pktdata), 0x00, sgt_size);
+                    uint32_t sgt_size = fuzz_get_sgt_size(r, datalen);
+                    memset(pktdata, 0x00, sgt_size);
                     packet_changed = 1;
                 }
                 break;
@@ -123,10 +199,9 @@ fuzzing(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr,
                 {
                     /* fuzz random-size segment at the begining of the packet with random Bytes */
                     int i;
-                    uint32_t r = rand();
-                    uint32_t sgt_size = fuzz_get_sgt_size(r, (*len));
+                    uint32_t sgt_size = fuzz_get_sgt_size(r, datalen);
                     for (i = 0; i < sgt_size; i++) {
-                        (*pktdata)[i] = (*pktdata)[i] ^ (r >> 4);
+                        pktdata[i] = pktdata[i] ^ (r >> 4);
                     }
                     packet_changed = 1;
                 }
@@ -134,38 +209,34 @@ fuzzing(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr,
             case FUZZING_CHANGE_START_FF:
                 {
                     /* fuzz random-size segment at the begining of the packet with 0xff */
-                    uint32_t r = rand();
-                    uint32_t sgt_size = fuzz_get_sgt_size(r, (*len));
-                    memset((*pktdata), 0xff, sgt_size);
+                    uint32_t sgt_size = fuzz_get_sgt_size(r, datalen);
+                    memset(pktdata, 0xff, sgt_size);
                     packet_changed = 1;
                 }
                 break;
             case FUZZING_CHANGE_MID_ZERO:
                 {
                     /* fuzz random-size segment inside the packet with 0x00 */
-                    uint32_t r = rand();
                     uint32_t offset = ((r >> 16) % ((*len) - 1)) + 1;
-                    uint32_t sgt_size = fuzz_get_sgt_size(r, (*len) - offset);
-                    memset((*pktdata) + offset, 0x00, sgt_size);
+                    uint32_t sgt_size = fuzz_get_sgt_size(r, datalen - offset);
+                    memset(pktdata + offset, 0x00, sgt_size);
                     packet_changed = 1;
                 }
                 break;
             case FUZZING_CHANGE_MID_FF:
                 {
                     /* fuzz random-size segment inside the packet with 0xff */
-                    uint32_t r = rand();
                     uint32_t offset = ((r >> 16) % ((*len) - 1)) + 1;
-                    uint32_t sgt_size = fuzz_get_sgt_size(r, (*len) - offset);
-                    memset((*pktdata) + offset, 0xff, sgt_size);
+                    uint32_t sgt_size = fuzz_get_sgt_size(r, datalen - offset);
+                    memset(pktdata + offset, 0xff, sgt_size);
                     packet_changed = 1;
                 }
                 break;
             case FUZZING_CHANGE_END_ZERO:
                 {
                     /* fuzz random-sized segment at the end of the packet with 0x00 */
-                    uint32_t r = rand();
-                    uint32_t sgt_size = fuzz_get_sgt_size(r, (*len));
-                    memset((*pktdata) + (*len) - sgt_size, 0x00, sgt_size);
+                    uint32_t sgt_size = fuzz_get_sgt_size(r, datalen);
+                    memset(pktdata + (*len) - sgt_size, 0x00, sgt_size);
                     packet_changed = 1;
                 }
                 break;
@@ -173,10 +244,9 @@ fuzzing(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr,
                 {
                     /* fuzz random-sized segment at the end of the packet with random Bytes */
                     int i;
-                    uint32_t r = rand();
-                    uint32_t sgt_size = fuzz_get_sgt_size(r, (*len));
+                    uint32_t sgt_size = fuzz_get_sgt_size(r, datalen);
                     for (i = ((*len) - sgt_size); i < (*len); i++) {
-                        (*pktdata)[i] = (*pktdata)[i] ^ (r >> 4);
+                        pktdata[i] = pktdata[i] ^ (r >> 4);
                     }
                     packet_changed = 1;
                 }
@@ -184,9 +254,8 @@ fuzzing(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr,
             case FUZZING_CHANGE_END_FF:
                 {
                     /* fuzz random-sized segment at the end of the packet with 0xff00 */
-                    uint32_t r = rand();
-                    uint32_t sgt_size = fuzz_get_sgt_size(r, (*len));
-                    memset((*pktdata) + (*len) - sgt_size, 0xff, sgt_size);
+                    uint32_t sgt_size = fuzz_get_sgt_size(r, datalen);
+                    memset(pktdata + (*len) - sgt_size, 0xff, sgt_size);
                     packet_changed = 1;
                 }
                 break;
@@ -196,11 +265,10 @@ fuzzing(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr,
                 {
                     /* fuzz random-size segment inside the packet with random Bytes */
                     int i;
-                    uint32_t r = rand();
                     uint32_t offset = ((r >> 16) % ((*len) - 1)) + 1;
-                    uint32_t sgt_size = fuzz_get_sgt_size(r, (*len) - offset);
+                    uint32_t sgt_size = fuzz_get_sgt_size(r, datalen - offset);
                     for (i = offset; i < offset + sgt_size; i++) {
-                        (*pktdata)[i] = (*pktdata)[i] ^ (r >> 4);
+                        pktdata[i] = pktdata[i] ^ (r >> 4);
                     }
                     packet_changed = 1;
                 }
diff --git a/src/tcpedit/parse_args.c b/src/tcpedit/parse_args.c
index 5836f8f2..c1376b83 100644
--- a/src/tcpedit/parse_args.c
+++ b/src/tcpedit/parse_args.c
@@ -38,11 +38,12 @@
 int 
 tcpedit_post_args(tcpedit_t *tcpedit) {
     int rcode = 0;
+    int i;
     long ttl;
+    uint32_t seed = 1;
 
     assert(tcpedit);
 
-
     /* --pnat */
     if (HAVE_OPT(PNAT)) {
         int ct = STACKCT_OPT(PNAT);
@@ -166,11 +167,6 @@ tcpedit_post_args(tcpedit_t *tcpedit) {
         }
     }
 
-    /* --fuzz-seed */
-    if (HAVE_OPT(FUZZ_SEED)) {
-        tcpedit->fuzz_seed = OPT_VALUE_FUZZ_SEED;
-    }
-
     /* TCP/UDP port rewriting */
     if (HAVE_OPT(PORTMAP)) {
         int ct = STACKCT_OPT(PORTMAP);
@@ -203,15 +199,30 @@ tcpedit_post_args(tcpedit_t *tcpedit) {
     }
 
     /*
-     * IP address rewriting processing.  Call srandom() then add up
-     * 5 calls to random() as our mixer for randomizing.  This should
+     * IP address rewriting processing. Update seed by making
+     * 5 calls to tcpr_random() as our mixer for randomizing.  This should
      * work better since most people aren't going to write out values
      * close to 32bit integers.
      */
     if (HAVE_OPT(SEED)) {
         tcpedit->rewrite_ip = true;
-        srandom(OPT_VALUE_SEED);
-        tcpedit->seed = random() + random() + random() + random() + random();
+        seed = OPT_VALUE_SEED;
+    } else if (HAVE_OPT(FUZZ_SEED)) {
+        /* --fuzz-seed */
+        seed = OPT_VALUE_FUZZ_SEED;
+    }
+
+    for (i = 0; i < 5; ++i) {
+        seed = tcpr_random(&seed);
+    }
+
+    srandom(seed);
+    if (HAVE_OPT(SEED)) {
+        tcpedit->rewrite_ip = true;
+        tcpedit->seed = seed;
+    }  if (HAVE_OPT(FUZZ_SEED)) {
+        /* --fuzz-seed */
+        tcpedit->fuzz_seed = seed;
     }
 
     if (HAVE_OPT(ENDPOINTS)) {
diff --git a/src/tcpedit/plugins/dlt_en10mb/en10mb.c b/src/tcpedit/plugins/dlt_en10mb/en10mb.c
index 24788ce7..5b9597fd 100644
--- a/src/tcpedit/plugins/dlt_en10mb/en10mb.c
+++ b/src/tcpedit/plugins/dlt_en10mb/en10mb.c
@@ -239,10 +239,11 @@ dlt_en10mb_parse_opts(tcpeditdlt_t *ctx)
     /* --mac-seed */
     if (HAVE_OPT(ENET_MAC_SEED)) {
         int i,j;
-        srandom(config->random.set = OPT_VALUE_ENET_MAC_SEED);
+
+        config->random.set = OPT_VALUE_ENET_MAC_SEED;
 
         for (i = 0; i < 6; i++) {
-          config->random.mask[i] = (u_char) random() % 256;
+          config->random.mask[i] = (u_char)tcpr_random(&config->random.set) % 256;
           /* only unique numbers */
           for (j = 0; j < i; j++) {
             if (config->random.mask[i] == config->random.mask[j]) {
diff --git a/src/tcpedit/plugins/dlt_en10mb/en10mb_types.h b/src/tcpedit/plugins/dlt_en10mb/en10mb_types.h
index 240f3313..bc0375eb 100644
--- a/src/tcpedit/plugins/dlt_en10mb/en10mb_types.h
+++ b/src/tcpedit/plugins/dlt_en10mb/en10mb_types.h
@@ -59,7 +59,7 @@ typedef struct {
 } en10mb_sub_conf_t;
 
 typedef struct {
-    int set;
+    uint32_t set;
     int keep;
     tcpr_macaddr_t mask;
 } en10mb_random_conf_t;
diff --git a/src/tcpedit/portmap.c b/src/tcpedit/portmap.c
index 7a10d540..57d8dcec 100644
--- a/src/tcpedit/portmap.c
+++ b/src/tcpedit/portmap.c
@@ -220,6 +220,7 @@ parse_portmap(tcpedit_portmap_t ** portmap, const char *ourstr)
             portmap_ptr = portmap_ptr->next;
     }
 
+    safe_free(ourstrcpy);
     return 1;
 }
 
diff --git a/src/tcpedit/tcpedit_api.c b/src/tcpedit/tcpedit_api.c
index d3f76d69..f773b0d7 100644
--- a/src/tcpedit/tcpedit_api.c
+++ b/src/tcpedit/tcpedit_api.c
@@ -215,7 +215,8 @@ tcpedit_set_seed(tcpedit_t *tcpedit)
     assert(tcpedit);
 
     tcpedit->rewrite_ip = true;
-    tcpedit->seed = random() + random() + random() + random() + random();
+    tcpedit->seed = 1;
+    tcpedit->seed = tcpr_random(&tcpedit->seed);
 
     return TCPEDIT_OK;
 }
diff --git a/src/tcpedit/tcpedit_opts.def b/src/tcpedit/tcpedit_opts.def
index 01ee66a8..ae8aee9f 100644
--- a/src/tcpedit/tcpedit_opts.def
+++ b/src/tcpedit/tcpedit_opts.def
@@ -45,6 +45,7 @@ EOText;
 
 flag = {
     name        = seed;
+    flags-cant   = fuzz-seed;
     value       = s;
     arg-type    = number;
     descrip     = "Randomize src/dst IPv4/v6 addresses w/ given seed";
@@ -275,12 +276,24 @@ flag = {
     arg-type    = number;
     arg-default = 0;
     arg-range   = "0->";
-    descrip     = "Apply random fuzzing to the packets based on given seed";
+    descrip     = "Fuzz 1/8 packet. Edit Bytes, length, or emulate packet drop";
     doc         = <<- EOText
-This fuzzing was designed as to test high-level protocols. It modifies randomly
-1 out of 8 packets in order for stateful protocols to cover more of their code.
-The random fuzzing actions focus on data start and end because it often is the
-part of the data high-level protocols base their decisions on.
+This fuzzing was designed as to test layer 7 protocols such as voip protocols.
+It modifies randomly 1 out of 8 packets in order for stateful protocols to cover
+more of their code.  The random fuzzing actions focus on data start and end
+because it often is the part of the data application protocols base their
+decisions on.
+
+Possible fuzzing actions list:
+ * drop packet
+ * reduce packet size
+ * edit packet Bytes:
+   * Not all Bytes have the same probability of appearance in real life.
+     Replace with 0x00, 0xFF, or a random byte with equal likelyhook
+   * Not all Bytes have the same significance in a packet.
+     Replace the start, the end, or the middle of the packet with equal likelyhood.
+ * do nothing (7 out of 8 packets)
+
 EOText;
 };
 
diff --git a/src/tcpedit/tcpedit_types.h b/src/tcpedit/tcpedit_types.h
index f78ec8dd..b1466e52 100644
--- a/src/tcpedit/tcpedit_types.h
+++ b/src/tcpedit/tcpedit_types.h
@@ -147,7 +147,7 @@ typedef struct {
     tcpr_cidrmap_t *dstipmap;
     
     /* pseudo-randomize IP addresses using a seed */
-    int seed;
+    uint32_t seed;
     
     /* rewrite tcp/udp ports */
     tcpedit_portmap_t *portmap;
@@ -156,7 +156,7 @@ typedef struct {
     bool mtu_truncate;       /* Should we truncate frames > MTU? */
     int maxpacket;          /* L2 header + MTU */
 
-    unsigned long fuzz_seed;
+    uint32_t fuzz_seed;
 } tcpedit_t;
 
 
diff --git a/src/tcpliveplay.c b/src/tcpliveplay.c
index 486caa60..fc044a7e 100644
--- a/src/tcpliveplay.c
+++ b/src/tcpliveplay.c
@@ -90,6 +90,7 @@
 #include "tcpliveplay.h"
 #include "tcpliveplay_opts.h"
 #include "common/sendpacket.h"
+#include "common/utils.h"
 #include "send_packets.h"
 
 volatile int didsig;
@@ -106,6 +107,7 @@ unsigned int buf_write_index = 0;
 unsigned int sched_index = 0; 
 unsigned int initial_rseq=0; 
 sendpacket_t *sp;
+unsigned int seed = 0;
 
 const u_char *packet_keeper_rprev = NULL;
 ether_hdr *etherhdr_rprev = NULL; /*g for Global header pointers used in pcap_loop callback*/
@@ -151,7 +153,7 @@ main(int argc, char **argv)
     struct mac_addr new_remotemac;
     input_addr myip;
     struct mac_addr mymac;
-    unsigned int new_src_port = 0; 
+    int new_src_port = 0;
     unsigned int retransmissions = 0; 
     pcap_t *local_handle;
     char errbuf[PCAP_ERRBUF_SIZE];
@@ -182,6 +184,9 @@ main(int argc, char **argv)
     else
         new_src_port = atoi(argv[5]);
 
+    if (new_src_port < 0 || new_src_port > 65535)
+        errx(new_src_port, "Cannot use source port %d", new_src_port);
+
     printf("new source port:: %d\n", new_src_port);
 
     /* Establish a handler for SIGALRM signals. */
@@ -386,14 +391,25 @@ catch_alarm (int sig){
     signal (sig, catch_alarm);
 }
 
+static int tcplp_rand(void)
+{
+    struct timeval tv;
+
+    if (!seed) {
+        gettimeofday(&tv, NULL);
+        seed = (unsigned int)tv.tv_sec ^ (unsigned int)tv.tv_usec;
+    }
+
+    return tcpr_random(&seed);
+}
 /**
  * This function returns a random number between 49152 and 65535
  */
 int
-random_port() {
-    srand(time(NULL));
-    int port_num = 49152 + (rand() % 16383);
-    return port_num;
+random_port()
+{
+    int random = tcplp_rand();
+    return (49152 + (random % 16383));
 }
 
 
@@ -405,9 +421,7 @@ random_port() {
 int
 relative_sched(struct tcp_sched* sched, u_int32_t first_rseq, int num_packets){
     int i;
-    u_int32_t lseq_adjust; 
-    srand(time(NULL));
-    lseq_adjust = rand();  /*Local SEQ number for SYN packet*/
+    u_int32_t lseq_adjust = tcplp_rand();
     printf("Random Local SEQ: %u\n",lseq_adjust);
 
 
diff --git a/src/tcpreplay.c b/src/tcpreplay.c
index e1db3432..9fc851db 100644
--- a/src/tcpreplay.c
+++ b/src/tcpreplay.c
@@ -53,7 +53,7 @@ int debug = 0;
 
 tcpreplay_t *ctx;
 
-void flow_stats(const tcpreplay_t *ctx, bool unique_ip);
+static void flow_stats(const tcpreplay_t *ctx);
 
 int
 main(int argc, char *argv[])
@@ -148,11 +148,7 @@ main(int argc, char *argv[])
     if (ctx->stats.bytes_sent > 0) {
         packet_stats(&ctx->stats);
         if (ctx->options->flow_stats)
-            flow_stats(ctx, ctx->options->unique_ip
-#ifdef TCPREPLAY_EDIT
-                    || tcpedit->seed
-#endif
-                    );
+            flow_stats(ctx);
         sendpacket_getstat(ctx->intf1, buf, sizeof(buf));
         printf("%s", buf);
         if (ctx->intf2 != NULL) {
@@ -167,12 +163,12 @@ main(int argc, char *argv[])
 /**
  * Print various flow statistics
  */
-void
-flow_stats(const tcpreplay_t *ctx, bool unique_ip)
+static void flow_stats(const tcpreplay_t *ctx)
 {
     struct timeval diff;
     COUNTER diff_us;
     const tcpreplay_stats_t *stats = &ctx->stats;
+    const tcpreplay_opt_t *options = ctx->options;
     COUNTER flows_total = stats->flows;
     COUNTER flows_unique = stats->flows_unique;
     COUNTER flows_expired = stats->flows_expired;
@@ -194,10 +190,18 @@ flow_stats(const tcpreplay_t *ctx, bool unique_ip)
      * to the next then multiply by the number of
      * successful iterations.
      */
-    if (unique_ip && ctx->options->preload_pcap) {
-        flows_total *= ctx->iteration;
-        flows_unique *= ctx->iteration;
-        flows_expired *= ctx->iteration;
+    if (options->preload_pcap) {
+        if (ctx->options->unique_ip) {
+            flows_total *= ctx->last_unique_iteration;
+            flows_unique *= ctx->last_unique_iteration;
+            flows_expired *= ctx->last_unique_iteration;
+#ifdef TCPREPLAY_EDIT
+        } else if (tcpedit->seed) {
+            flows_total *= ctx->iteration;
+            flows_unique *= ctx->iteration;
+            flows_expired *= ctx->iteration;
+#endif
+        }
     }
 
     flow_packets  = stats->flow_packets * ctx->iteration;
diff --git a/src/tcpreplay_api.c b/src/tcpreplay_api.c
index 8d303228..d3bb9540 100644
--- a/src/tcpreplay_api.c
+++ b/src/tcpreplay_api.c
@@ -81,6 +81,7 @@ tcpreplay_init()
 {
     tcpreplay_t *ctx;
 
+    /* allocations will reset everything to zeros */
     ctx = safe_malloc(sizeof(tcpreplay_t));
     ctx->options = safe_malloc(sizeof(tcpreplay_opt_t));
 
@@ -89,7 +90,6 @@ tcpreplay_init()
 
     /* Default mode is to replay pcap once in real-time */
     ctx->options->speed.mode = speed_multiplier;
-    ctx->options->speed.speed = 0;
     ctx->options->speed.multiplier = 1.0;
 
     /* Set the default timing method */
@@ -104,8 +104,8 @@ tcpreplay_init()
     /* disable limit send */
     ctx->options->limit_send = -1;
 
-    /* disable limit time */
-    ctx->options->limit_time = 0;
+    /* default unique-loops */
+    ctx->options->unique_loops = 1.0;
 
 #ifdef ENABLE_VERBOSE
     /* clear out tcpdump struct */
@@ -126,7 +126,6 @@ tcpreplay_init()
     ctx->flow_hash_table = flow_hash_table_init(DEFAULT_FLOW_HASH_BUCKET_SIZE);
 
     ctx->sp_type = SP_TYPE_NONE;
-    ctx->iteration = 0;
     ctx->intf1dlt = -1;
     ctx->intf2dlt = -1;
     ctx->abort = false;
@@ -279,6 +278,15 @@ tcpreplay_post_args(tcpreplay_t *ctx, int argc)
     if (HAVE_OPT(UNIQUE_IP))
         options->unique_ip = 1;
 
+    if (HAVE_OPT(UNIQUE_IP_LOOPS)) {
+        options->unique_loops = atof(OPT_ARG(UNIQUE_IP_LOOPS));
+        if (options->unique_loops < 1.0) {
+            tcpreplay_seterr(ctx, "%s", "--unique-ip-loops requires loop count >= 1.0");
+            ret = -1;
+            goto out;
+        }
+    }
+
     /* flow statistics */
     if (HAVE_OPT(NO_FLOW_STATS))
         options->flow_stats = 0;
@@ -634,13 +642,21 @@ tcpreplay_set_loop(tcpreplay_t *ctx, u_int32_t value)
  * Set the unique IP address flag
  */
 int
-tcpreplay_set_unique_ip(tcpreplay_t *ctx, int value)
+tcpreplay_set_unique_ip(tcpreplay_t *ctx, bool value)
 {
     assert(ctx);
     ctx->options->unique_ip = value;
     return 0;
 }
 
+int
+tcpreplay_set_unique_ip_loops(tcpreplay_t *ctx, int value)
+{
+    assert(ctx);
+    ctx->options->unique_loops = value;
+    return 0;
+}
+
 /**
  * Set Quick TX mode
  */
@@ -1196,8 +1212,15 @@ tcpreplay_replay(tcpreplay_t *ctx)
     /* main loop, when not looping forever (or until abort) */
     if (ctx->options->loop > 0) {
         while (ctx->options->loop-- && !ctx->abort) {  /* limited loop */
-            if (ctx->options->stats == 0)
-                printf("Loop %d of %d...\n", ++loop, total_loops);
+            ++loop;
+            if (ctx->options->stats == 0) {
+                if (!ctx->unique_iteration || loop == ctx->unique_iteration)
+                    printf("Loop %d of %d...\n", loop, total_loops);
+                else
+                    printf("Loop %d of %d (" COUNTER_SPEC " unique)...\n",
+                            loop, total_loops,
+                            ctx->unique_iteration);
+            }
             if ((rcode = tcpr_replay_index(ctx)) < 0)
                 return rcode;
             if (ctx->options->loop > 0) {
@@ -1212,8 +1235,14 @@ tcpreplay_replay(tcpreplay_t *ctx)
         }
     } else {
         while (!ctx->abort) { /* loop forever unless user aborts */
-            if (ctx->options->stats == 0)
-                printf("Loop %d...\n", ++loop);
+            ++loop;
+            if (ctx->options->stats == 0) {
+                if (!ctx->unique_iteration || loop == ctx->unique_iteration)
+                    printf("Loop %d...\n", loop);
+                else
+                    printf("Loop %d (" COUNTER_SPEC " unique)...\n", loop,
+                            ctx->unique_iteration);
+            }
             if ((rcode = tcpr_replay_index(ctx)) < 0)
                 return rcode;
 
diff --git a/src/tcpreplay_api.h b/src/tcpreplay_api.h
index 8f4b9c5a..6cf53583 100644
--- a/src/tcpreplay_api.h
+++ b/src/tcpreplay_api.h
@@ -158,6 +158,7 @@ typedef struct tcpreplay_opt_s {
     int flow_expiry;
 
     int unique_ip;
+    float unique_loops;
 } tcpreplay_opt_t;
 
 
@@ -177,6 +178,8 @@ typedef struct tcpreplay_s {
     int intf1dlt;
     int intf2dlt;
     COUNTER iteration;
+    COUNTER unique_iteration;
+    COUNTER last_unique_iteration;
     sendpacket_type_t sp_type;
     char errstr[TCPREPLAY_ERRSTR_LEN];
     char warnstr[TCPREPLAY_ERRSTR_LEN];
@@ -233,7 +236,8 @@ int tcpreplay_set_speed_mode(tcpreplay_t *, tcpreplay_speed_mode);
 int tcpreplay_set_speed_speed(tcpreplay_t *, COUNTER);
 int tcpreplay_set_speed_pps_multi(tcpreplay_t *, int);
 int tcpreplay_set_loop(tcpreplay_t *, u_int32_t);
-int tcpreplay_set_unique_ip(tcpreplay_t *, int);
+int tcpreplay_set_unique_ip(tcpreplay_t *, bool);
+int tcpreplay_set_unique_ip_loops(tcpreplay_t *, int);
 int tcpreplay_set_quick_tx(tcpreplay_t *, bool);
 int tcpreplay_set_netmap(tcpreplay_t *, bool);
 int tcpreplay_set_use_pkthdr_len(tcpreplay_t *, bool);
diff --git a/src/tcpreplay_opts.def b/src/tcpreplay_opts.def
index faed1715..b57a10fa 100644
--- a/src/tcpreplay_opts.def
+++ b/src/tcpreplay_opts.def
@@ -471,9 +471,11 @@ EOText;
 
 flag = {
     name        = unique-ip;
+    flags-must   = loop;
 #ifdef TCPREPLAY_EDIT
-	flags-cant	= seed;
-#endif    
+    flags-cant   = seed;
+    flags-cant   = fuzz-seed;
+#endif
     descrip     = "Modify IP addresses each loop iteration to generate unique flows";
     doc         = <<- EOText
 Ensure IPv4 and IPv6 packets will be unique for each @var{--loop} iteration. 
@@ -483,6 +485,18 @@ generated over multiple loop iterations.
 EOText;
 };
 
+flag = {
+    name        = unique-ip-loops;
+    flags-must   = unique-ip;
+    arg-type    = string;
+    max         = 1;
+    descrip     = "Number of times to loop before assigning new unique ip";
+    doc         = <<- EOText
+Number of @var{--loop} iterations before a new unique IP is assigned. Default
+is 1. Assumes both @var{--loop} and @var{--unique-ip}.
+EOText;
+};
+
 flag = {
     ifdef       = HAVE_NETMAP;
     name        = netmap;
diff --git a/src/tcprewrite.c b/src/tcprewrite.c
index 1ba2906e..18214050 100644
--- a/src/tcprewrite.c
+++ b/src/tcprewrite.c
@@ -240,9 +240,6 @@ rewrite_packets(tcpedit_t *tcpedit, pcap_t *pin, pcap_dumper_t *pout)
     int rcode;
 #ifdef ENABLE_FRAGROUTE
     int frag_len, proto;
-#ifdef DEBUG
-    int i;
-#endif
 #endif
 
     pkthdr_ptr = &pkthdr;
@@ -310,12 +307,11 @@ rewrite_packets(tcpedit_t *tcpedit, pcap_t *pin, pcap_dumper_t *pout)
 
             /* packet is IPv4/IPv6 AND needs to be fragmented */
             if ((proto ==  ETHERTYPE_IP || proto == ETHERTYPE_IP6) &&
-                ((options.fragroute_dir == FRAGROUTE_DIR_BOTH) ||
-                 (cache_result == TCPR_DIR_C2S && options.fragroute_dir == FRAGROUTE_DIR_C2S) ||
-                 (cache_result == TCPR_DIR_S2C && options.fragroute_dir == FRAGROUTE_DIR_S2C))) {
-
+                    ((options.fragroute_dir == FRAGROUTE_DIR_BOTH) ||
+                    (cache_result == TCPR_DIR_C2S && options.fragroute_dir == FRAGROUTE_DIR_C2S) ||
+                    (cache_result == TCPR_DIR_S2C && options.fragroute_dir == FRAGROUTE_DIR_S2C))) {
 #ifdef DEBUG
-                i = 0;
+                int i = 0;
 #endif
                 if (fragroute_process(options.frag_ctx, *pktdata, pkthdr_ptr->caplen) < 0)
                     errx(-1, "Error processing packet via fragroute: %s", options.frag_ctx->errbuf);
diff --git a/src/tree.c b/src/tree.c
index 0e99cd28..6670a810 100644
--- a/src/tree.c
+++ b/src/tree.c
@@ -280,7 +280,8 @@ check_ip_tree(const int mode, const unsigned long ip)
         }
     }
     
-    return_unknown:
+return_unknown:
+    safe_free(finder);
     switch (mode) {
     case DIR_SERVER:
         return TCPR_DIR_S2C;
@@ -348,7 +349,8 @@ check_ip6_tree(const int mode, const struct tcpr_in6_addr *addr)
         }
     }
 
-    return_unknown:
+return_unknown:
+    safe_free(finder);
     switch (mode) {
     case DIR_SERVER:
         return TCPR_DIR_C2S;
@@ -739,7 +741,9 @@ packet2tree(const u_char * data)
 
 
     /* copy over the source mac */
-    strncpy((char *)node->mac, (char *)eth_hdr->ether_shost, 6);
+    memset(&node->mac[0], 0, sizeof(node->mac));
+    strncpy((char *)node->mac, (char *)eth_hdr->ether_shost,
+		    sizeof(node->mac) - 1);
 
     /* 
      * TCP 
diff --git a/test/Makefile.am b/test/Makefile.am
index 11a67dea..7c4601b8 100644
--- a/test/Makefile.am
+++ b/test/Makefile.am
@@ -23,7 +23,8 @@ EXTRA_DIST = test.pcap test.auto_bridge test.auto_client test.auto_router \
 		test.rewrite_skip test.rewrite_dltuser test.rewrite_dlthdlc \
 		test.rewrite_vlandel test.rewrite_efcs test.rewrite_1ttl \
 		test.rewrite_2ttl test.rewrite_3ttl test.rewrite_enet_subsmac \
-		test.rewrite_mac_seed test.rewrite_mac_seed_keep test.rewrite_l7fuzzing \
+		test.rewrite_mtutrunc test.rewrite_mac_seed \
+		test.rewrite_mac_seed_keep test.rewrite_l7fuzzing\
 		test2.rewrite_seed test2.rewrite_portmap test2.rewrite_endpoint \
 		test2.rewrite_pnat test2.rewrite_pad test2.rewrite_trunc \
 		test2.rewrite_mac test2.rewrite_layer2 test2.rewrite_config \
@@ -31,9 +32,8 @@ EXTRA_DIST = test.pcap test.auto_bridge test.auto_client test.auto_router \
 		test2.rewrite_vlandel test2.rewrite_efcs test2.rewrite_1ttl \
 		test2.rewrite_mtutrunc test2.rewrite_enet_subsmac \
 		test2.rewrite_2ttl test2.rewrite_3ttl test.rewrite_tos test2.rewrite_tos \
-		test2.rewrite_l7fuzzing \
 		test2.rewrite_enet_subsmac test2.rewrite_mac_seed \
-		test2.rewrite_mac_seed_keep
+		test2.rewrite_mac_seed_keep test2.rewrite_l7fuzzing
 
 test: all
 all: clearlog check tcpprep tcpreplay tcprewrite
@@ -108,7 +108,8 @@ standard_bigendian:
 	$(TCPREWRITE) -i test.pcap -o test.rewrite_1ttl --ttl=58
 	$(TCPREWRITE) -i test.pcap -o test.rewrite_2ttl --ttl=+58
 	$(TCPREWRITE) -i test.pcap -o test.rewrite_3ttl --ttl=-58
-	$(TCPREWRITE) -i test.pcap -o test.rewrite_mtutrunc --fuzz-seed=42
+	$(TCPREWRITE) -i test.pcap -o test.rewrite_mtutrunc --mtu-trunc --mtu=300
+	$(TCPREWRITE) -i test.pcap -o test.rewrite_l7fuzzing --fuzz-seed=42
 
 standard_littleendian:
 	$(TCPREWRITE) -i test.pcap -o test2.rewrite_seed -s 55
@@ -147,7 +148,7 @@ standard_littleendian:
 	$(TCPREWRITE) -i test.pcap -o test2.rewrite_2ttl --ttl=+58
 	$(TCPREWRITE) -i test.pcap -o test2.rewrite_3ttl --ttl=-58
 	$(TCPREWRITE) -i test.pcap -o test2.rewrite_mtutrunc --mtu-trunc --mtu=300
-	$(TCPREWRITE) -i test.pcap -o test2.rewrite_mtutrunc --fuzz-seed=42
+	$(TCPREWRITE) -i test.pcap -o test2.rewrite_l7fuzzing --fuzz-seed=42
 
 tcpprep: auto_router auto_bridge auto_client auto_server auto_first cidr regex \
 	port mac comment print_info print_comment prep_config \
@@ -157,8 +158,7 @@ tcprewrite: rewrite_portmap rewrite_endpoint rewrite_pnat rewrite_trunc \
 	rewrite_pad rewrite_seed rewrite_mac rewrite_layer2 rewrite_config \
 	rewrite_skip rewrite_dltuser rewrite_dlthdlc rewrite_vlandel rewrite_efcs \
 	rewrite_1ttl rewrite_2ttl rewrite_3ttl rewrite_tos rewrite_mtutrunc \
-	rewrite_enet_subsmac rewrite_mac_seed rewrite_mac_seed_keep \
-	rewrite_l7fuzzing
+	rewrite_enet_subsmac rewrite_mac_seed rewrite_mac_seed_keep rewrite_l7fuzzing
 
 tcpreplay: replay_basic replay_cache replay_pps replay_rate replay_top \
 	replay_config replay_multi replay_pps_multi replay_precache \
@@ -301,7 +301,7 @@ replay_stats:
 rewrite_portmap:
 	$(PRINTF) "%s" "[tcprewrite] Portmap test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Portmap test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.rewrite_portmap1 -r 80:8080 >>test.log 2>&1
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -r 80:8080 >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
 else
@@ -312,7 +312,7 @@ endif
 rewrite_endpoint:
 	$(PRINTF) "%s" "[tcprewrite] Endpoint test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Endpoint test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.rewrite_endpoint1 -e 10.10.0.1:10.10.0.2 \
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -e 10.10.0.1:10.10.0.2 \
 	    -c test.auto_router  >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
@@ -324,7 +324,7 @@ endif
 rewrite_pnat:
 	$(PRINTF) "%s" "[tcprewrite] Pseudo NAT test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Pseudo NAT test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.rewrite_pnat1 \
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 \
 	    -N 216.27.178.0/24:172.16.0.0/24  >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
@@ -336,7 +336,7 @@ endif
 rewrite_mac:
 	$(PRINTF) "%s" "[tcprewrite] Src/Dst MAC test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Src/Dst MAC test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.rewrite_mac1 \
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 \
 		--enet-dmac=00:12:13:14:15:16,00:22:33:44:55:66 \
 		--enet-smac=00:22:33:44:55:66,00:12:13:14:15:16  -c test.auto_router  >>test.log 2>&1
 if WORDS_BIGENDIAN
@@ -349,7 +349,7 @@ endif
 rewrite_enet_subsmac:
 	$(PRINTF) "%s" "[tcprewrite] Substitute Src/Dst MAC test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Substitute Src/Dst MAC test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.rewrite_enet_subsmac1 \
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 \
 		--enet-subsmac=00:1f:f3:3c:e1:13,00:22:33:44:55:66 \
 		--enet-subsmac=f8:1e:df:e5:84:3a,00:66:55:44:33:22  >>test.log 2>&1
 if WORDS_BIGENDIAN
@@ -362,7 +362,7 @@ endif
 rewrite_mac_seed:
 	$(PRINTF) "%s" "[tcprewrite] Seeded MAC test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Seeded MAC test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.rewrite_mac_seed1 \
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 \
 		--enet-mac-seed=42 >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
@@ -374,7 +374,7 @@ endif
 rewrite_mac_seed_keep:
 	$(PRINTF) "%s" "[tcprewrite] Seeded Keep MAC test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Seeded Keep MAC test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.rewrite_mac_seed_keep1 \
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 \
 		--enet-mac-seed=42 --enet-mac-seed-keep-bytes=3 >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
@@ -386,7 +386,7 @@ endif
 rewrite_trunc:
 	$(PRINTF) "%s" "[tcprewrite] Truncate test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Truncate test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -F trunc -i test.pcap -o test.rewrite_trunc1 >>test.log 2>&1
+	$(TCPREWRITE) $(ENABLE_DEBUG) -F trunc -i test.pcap -o test.$@1 >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
 else
@@ -397,7 +397,7 @@ endif
 rewrite_pad:
 	$(PRINTF) "%s" "[tcprewrite] Pad test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Pad test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -F pad -i test.pcap -o test.rewrite_pad1 >>test.log 2>&1
+	$(TCPREWRITE) $(ENABLE_DEBUG) -F pad -i test.pcap -o test.$@1 >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
 else
@@ -408,7 +408,7 @@ endif
 rewrite_seed:
 	$(PRINTF) "%s" "[tcprewrite] Seed IP test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Seed IP test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.rewrite_seed1 -s 55 >>test.log 2>&1
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -s 55 >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
 else
@@ -420,7 +420,7 @@ rewrite_layer2:
 	$(PRINTF) "%s" "[tcprewrite] Layer2 test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Layer2 test: " >>test.log
 	$(TCPREWRITE) $(ENABLE_DEBUG) --dlt=user --user-dlink=00,50,da,5d,46,55,0,7,eb,30,a4,c3,08,0 \
-		-i test.pcap -o test.rewrite_layer21 >>test.log 2>&1
+		-i test.pcap -o test.$@1 >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
 else
@@ -442,7 +442,7 @@ endif
 rewrite_skip:
 	$(PRINTF) "%s" "[tcprewrite] Skip bcast test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Skip bcast test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.rewrite_skip1 -b -s 55 \
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -b -s 55 \
 		--enet-dmac=00:12:13:14:15:16,00:22:33:44:55:66 \
 		--enet-smac=00:22:33:44:55:66,00:12:13:14:15:16  -c test.auto_router  >>test.log 2>&1
 if WORDS_BIGENDIAN
@@ -455,7 +455,7 @@ endif
 rewrite_dltuser:
 	$(PRINTF) "%s" "[tcprewrite] DLT User test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] DLT User test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.rewrite_dltuser1 --dlt=user \
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 --dlt=user \
 		--user-dlink=0x0f,0x00,0x08,0x00 --user-dlt=104  >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
@@ -467,7 +467,7 @@ endif
 rewrite_dlthdlc:
 	$(PRINTF) "%s" "[tcprewrite] DLT Cisco HDLC test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] DLT Cisco HDLC test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.rewrite_dlthdlc1 --dlt=hdlc \
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 --dlt=hdlc \
 		--hdlc-control=0 --hdlc-address=0x0F  >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
@@ -479,7 +479,7 @@ endif
 rewrite_vlandel:
 	$(PRINTF) "%s" "[tcprewrite] VLAN Delete test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] VLAN Delete test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.rewrite_config -o test.rewrite_vlandel1 \
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.rewrite_config -o test.$@1 \
 		--enet-vlan=del  >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
@@ -491,7 +491,7 @@ endif
 rewrite_efcs:
 	$(PRINTF) "%s" "[tcprewrite] Remove EFCS: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Remove EFCS: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.rewrite_efcs1 --efcs >>test.log 2>&1
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 --efcs >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
 else
@@ -555,8 +555,8 @@ endif
 	if [ $? ] ; then $(PRINTF) "\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t%s\n" "OK"; fi
 
 rewrite_l7fuzzing:
-	$(PRINTF) "%s" "[tcprewrite] l7 fuzzing test: "
-	$(PRINTF) "%s\n" "*** [tcprewrite] MTU Truncate test: " >>test.log
+	$(PRINTF) "%s" "[tcprewrite] L7 fuzzing test: "
+	$(PRINTF) "%s\n" "*** [tcprewrite] L7 fuzzing test: " >>test.log
 	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 --fuzz-seed=42 >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
@@ -565,7 +565,6 @@ else
 endif
 	if [ $? ] ; then $(PRINTF) "\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t\t%s\n" "OK"; fi
 
-
 replay_pps:
 	$(PRINTF) "%s" "[tcpreplay] Packets/sec test: "
 	$(PRINTF) "%s\n" "*** [tcpreplay] Packets/sec test: " >>test.log
diff --git a/test/test.rewrite_1ttl b/test/test.rewrite_1ttl
index b389d550..d5805bf7 100644
Binary files a/test/test.rewrite_1ttl and b/test/test.rewrite_1ttl differ
diff --git a/test/test.rewrite_2ttl b/test/test.rewrite_2ttl
index 24d59ca0..09c32ab4 100644
Binary files a/test/test.rewrite_2ttl and b/test/test.rewrite_2ttl differ
diff --git a/test/test.rewrite_3ttl b/test/test.rewrite_3ttl
index 904a0cb5..c33ad4ff 100644
Binary files a/test/test.rewrite_3ttl and b/test/test.rewrite_3ttl differ
diff --git a/test/test.rewrite_config b/test/test.rewrite_config
index 80b162b4..7cc119d1 100644
Binary files a/test/test.rewrite_config and b/test/test.rewrite_config differ
diff --git a/test/test.rewrite_dlthdlc b/test/test.rewrite_dlthdlc
index f19d5317..29852c3e 100644
Binary files a/test/test.rewrite_dlthdlc and b/test/test.rewrite_dlthdlc differ
diff --git a/test/test.rewrite_dltuser b/test/test.rewrite_dltuser
index 8db41020..90b37b82 100644
Binary files a/test/test.rewrite_dltuser and b/test/test.rewrite_dltuser differ
diff --git a/test/test.rewrite_efcs b/test/test.rewrite_efcs
index 18acbd10..453cd87a 100644
Binary files a/test/test.rewrite_efcs and b/test/test.rewrite_efcs differ
diff --git a/test/test.rewrite_endpoint b/test/test.rewrite_endpoint
index cf08a9fc..bf6e4c75 100644
Binary files a/test/test.rewrite_endpoint and b/test/test.rewrite_endpoint differ
diff --git a/test/test.rewrite_enet_subsmac b/test/test.rewrite_enet_subsmac
index 5d063925..ef281f2b 100644
Binary files a/test/test.rewrite_enet_subsmac and b/test/test.rewrite_enet_subsmac differ
diff --git a/test/test.rewrite_l7fuzzing b/test/test.rewrite_l7fuzzing
index 514c28b2..b31ce7cf 100644
Binary files a/test/test.rewrite_l7fuzzing and b/test/test.rewrite_l7fuzzing differ
diff --git a/test/test.rewrite_layer2 b/test/test.rewrite_layer2
index 1016a166..f0d5532d 100644
Binary files a/test/test.rewrite_layer2 and b/test/test.rewrite_layer2 differ
diff --git a/test/test.rewrite_mac b/test/test.rewrite_mac
index 18ed3b41..3f0e2f69 100644
Binary files a/test/test.rewrite_mac and b/test/test.rewrite_mac differ
diff --git a/test/test.rewrite_mac_seed b/test/test.rewrite_mac_seed
index ec843531..a313da08 100644
Binary files a/test/test.rewrite_mac_seed and b/test/test.rewrite_mac_seed differ
diff --git a/test/test.rewrite_mac_seed_keep b/test/test.rewrite_mac_seed_keep
index 15713df6..440c995b 100644
Binary files a/test/test.rewrite_mac_seed_keep and b/test/test.rewrite_mac_seed_keep differ
diff --git a/test/test.rewrite_mtutrunc b/test/test.rewrite_mtutrunc
new file mode 100644
index 00000000..766d5538
Binary files /dev/null and b/test/test.rewrite_mtutrunc differ
diff --git a/test/test.rewrite_pad b/test/test.rewrite_pad
index 01e48319..25aab90a 100644
Binary files a/test/test.rewrite_pad and b/test/test.rewrite_pad differ
diff --git a/test/test.rewrite_pnat b/test/test.rewrite_pnat
index 9f6dd86e..25aab90a 100644
Binary files a/test/test.rewrite_pnat and b/test/test.rewrite_pnat differ
diff --git a/test/test.rewrite_portmap b/test/test.rewrite_portmap
index 45621881..60b54d96 100644
Binary files a/test/test.rewrite_portmap and b/test/test.rewrite_portmap differ
diff --git a/test/test.rewrite_seed b/test/test.rewrite_seed
index b19582e1..749615e4 100644
Binary files a/test/test.rewrite_seed and b/test/test.rewrite_seed differ
diff --git a/test/test.rewrite_skip b/test/test.rewrite_skip
index 9de85ecb..c4019eb3 100644
Binary files a/test/test.rewrite_skip and b/test/test.rewrite_skip differ
diff --git a/test/test.rewrite_tos b/test/test.rewrite_tos
index 44a39cbe..60fb5e0e 100644
Binary files a/test/test.rewrite_tos and b/test/test.rewrite_tos differ
diff --git a/test/test.rewrite_trunc b/test/test.rewrite_trunc
index 6d3a7dfd..25aab90a 100644
Binary files a/test/test.rewrite_trunc and b/test/test.rewrite_trunc differ
diff --git a/test/test.rewrite_vlandel b/test/test.rewrite_vlandel
index ccdb6b37..25aab90a 100644
Binary files a/test/test.rewrite_vlandel and b/test/test.rewrite_vlandel differ
diff --git a/test/test2.rewrite_l7fuzzing b/test/test2.rewrite_l7fuzzing
index 514c28b2..8defcee0 100644
Binary files a/test/test2.rewrite_l7fuzzing and b/test/test2.rewrite_l7fuzzing differ
diff --git a/test/test2.rewrite_mac_seed b/test/test2.rewrite_mac_seed
index ec843531..8145c26f 100644
Binary files a/test/test2.rewrite_mac_seed and b/test/test2.rewrite_mac_seed differ
diff --git a/test/test2.rewrite_mac_seed_keep b/test/test2.rewrite_mac_seed_keep
index 15713df6..af73239e 100644
Binary files a/test/test2.rewrite_mac_seed_keep and b/test/test2.rewrite_mac_seed_keep differ
diff --git a/test/test2.rewrite_seed b/test/test2.rewrite_seed
index 7e4ca933..8a3d6877 100644
Binary files a/test/test2.rewrite_seed and b/test/test2.rewrite_seed differ
diff --git a/test/test2.rewrite_skip b/test/test2.rewrite_skip
index f7a0d4d5..1c37951f 100644
Binary files a/test/test2.rewrite_skip and b/test/test2.rewrite_skip differ
diff --git a/test/test2.rewrite_vlandel b/test/test2.rewrite_vlandel
index e547ad3d..2ef0a9c5 100644
Binary files a/test/test2.rewrite_vlandel and b/test/test2.rewrite_vlandel differ
